#ShowCheckersAndDice.py

import sys
sys.path.append("minidrawmod.jar")

from minidraw.standard  import *
from minidraw.framework import *

from java.awt import *
from javax.swing import *

def main():
    editor = MiniDrawApplication("Show HotGammon figures...", HotGammonFactory())
    editor.open()

    redDie = ImageFigure("die4", Point(216, 202))
    blackDie = ImageFigure("die2", Point(306, 202))
    editor.drawing().add(redDie)
    editor.drawing().add(blackDie)

    bc = ImageFigure("blackchecker", Point(21,21))
    editor.drawing().add(bc)

    rc = ImageFigure("redchecker", Point(507, 390))
    editor.drawing().add(rc)

    editor.setTool( SelectionTool(editor))

class HotGammonFactory(Factory):

    def createDrawingView(self, editor):
        return StdViewWithBackground(editor, "board")

    def createDrawing(self, editor):
        return StandardDrawing()

    def createStatusField(self, editor):
        statusField = JTextField("Hello HotGammon...")
        statusField.setEditable(False)
        return statusField

main()
