# convert.py
#   convert between view locations and board locations

from java.awt import Point

from location import *

_rectMap = { B12: (15 + 0*40, 20, 40, 200),
             B11: (15 + 1 * 40, 20, 40, 200),
             B10: (15 + 2 * 40, 20, 40, 200),
             B9:  (15 + 3 * 40, 20, 40, 200),
             B8:  (15 + 4 * 40, 20, 40, 200),
             B7:  (15 + 5 * 40, 20, 40, 200),
    
             B6: (300 + 0 * 40, 20, 40, 200),
             B5: (300 + 1 * 40, 20, 40, 200),
             B4: (300 + 2 * 40, 20, 40, 200),
             B3: (300 + 3 * 40, 20, 40, 200),
             B2: (300 + 4 * 40, 20, 40, 200),
             B1: (300 + 5 * 40, 20, 40, 200),
    
             R12: (15 + 0 * 40, 217, 40, 200),
             R11: (15 + 1 * 40, 217, 40, 200),
             R10: (15 + 2 * 40, 217, 40, 200),
             R9:  (15 + 3 * 40, 217, 40, 200),
             R8:  (15 + 4 * 40, 217, 40, 200),
             R7:  (15 + 5 * 40, 217, 40, 200),
    
             R6:  (300 + 0 * 40, 217, 40, 200),
             R5:  (300 + 1 * 40, 217, 40, 200),
             R4:  (300 + 2 * 40, 217, 40, 200),
             R3:  (300 + 3 * 40, 217, 40, 200),
             R2:  (300 + 4 * 40, 217, 40, 200),
             R1:  (300 + 5 * 40, 217, 40, 200),
    
             B_BAR: (260, 220, 36, 200),
             B_BEAR_OFF: (545, 12, 40, 200),
             R_BAR: (260, 12, 36, 200),
             R_BEAR_OFF: (545, 220, 40, 200)
           }


def xy2location(x,y):
    for loc in LOCATIONS:
        rx, ry, width, height = _rectMap[loc]
        if rx <= x <= rx+width and ry <= y <= ry+height:
            return loc
    return None

def locAndCount2xy(loc, count):
    boxX, boxY, boxW, boxH = _rectMap[loc]
    size = 27 # magic constant, size of checker gif

    newx = boxX + (boxW-size) / 2
    if loc in [B_BEAR_OFF, R_BEAR_OFF]:
        size = size / 2
    # if on back side of board
    if loc in [B1, B2, B3, B4, B5, B6, B7,
               B8, B9, B10, B11, B12, B_BEAR_OFF, R_BAR]:
        newy = size * count + boxY
    elif loc == R_BEAR_OFF:
        newy = boxY+boxH -(size*(count+2))
    else:
        newy = boxY + boxH - size*(count+1)

    return Point(newx, newy)

